import OSS from 'ali-oss'
/**
 * 配置信息
 */
const region = 'oss-cn-beijing'
const accessKeyId = 'LTAI5tJe94eBRuNzuVFyt1C2'
const accessKeySecret = 'YRhe8lc7vpbxX8Fi4qvosDqVERFdjJ'
const bucket = 'yangguzhineng'
const folder = 'test'
import { Message } from 'element-ui'

let client = new OSS({
	region: region,
	accessKeyId: accessKeyId,
	accessKeySecret: accessKeySecret,
	bucket: bucket
})

/**
 *
 * @param {上传是设置文件key , 一般为文件名称} objectKey
 * @param {文件file} file
 */

//  上传
const CooOss = function (file) {
	if (this instanceof CooOss) {
		let objectKey = folder + '/' + file.lastModified + '_' + getFileNameUUID()
		return new Promise((resolve, reject) => {
			client
				.multipartUpload(objectKey, file, {
					progress: function (p) {
						//上传进度
						console.log(p)
					}
				})
				.then((result) => {
					resolve({
						code: 200,
						url: this.getOssFileUrl(objectKey),
						msg: 'ok'
					})
				})
				.catch((err) => {
					Message.error('上传出错了')
					reject({ code: 500, url: '', objectKey: '', msg: '上传出错了' })
				})
		})
	} else {
		return new CooOss(file)
	}
}

// 下载
export const download = function (key) {
	console.log(key)
	let url = client.signatureUrl(key)
	let Img = new Image(),
		dataURL = ''
	let fileName = key.substring(key.indexOf('_') + 1)
	Img.src = url
	Img.setAttribute('crossOrigin', 'Anonymous')
	Img.onload = function () {
		let canvas = document.createElement('canvas'),
			width = Img.width,
			height = Img.height
		canvas.width = width
		canvas.height = height
		canvas.getContext('2d').drawImage(Img, 0, 0, width, height)
		dataURL = canvas.toDataURL('image/png')
		let eleLink = document.createElement('a')
		eleLink.download = fileName
		eleLink.style.display = 'none'
		eleLink.href = dataURL
		document.body.appendChild(eleLink)
		eleLink.click()
		document.body.removeChild(eleLink)
	}
}
/**
 *
 * @param {上传是设置文件key 一般是文件名} obecjtKey
 */
CooOss.prototype.getOssFileUrl = (obecjtKey) => {
	if (!obecjtKey) return new Error('object key 必须传')
	return 'https://' + bucket + '.' + region + '.aliyuncs.com/' + obecjtKey
}

const getFileNameUUID = () => {
	function rx() {
		return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1)
	}
	return `${+new Date()}_${rx()}${rx()}`
}
export default CooOss
